﻿using System;
using NLite;
using NLite.Cfg;
using NLite.Domain;

namespace ConsoleDemo
{
    class Program
    {
        static void Main(string[] args)
        {
            //Config Ndf 组件
            new Configuration().Configure();

            //Registery CalculteService in current assembly
            ServiceRegistry.RegisteryFromAssemblyOf<Program>();

            //call CalculteService.Add method
            int result = ServiceDispatcher.Dispatch<int>("calculate", "add", new { a = 2, b = 3 });
            Console.WriteLine("2 + 3 = " + result.ToString());

            //call CalculteService.Sub method
            result = ServiceDispatcher.Dispatch<int>("calculate", "sub", new { a = 2, b = 3 });
            Console.WriteLine("2 - 3 = " + result.ToString());

            //call CalculteService.Multiply method
            result = ServiceDispatcher.Dispatch<int>("calculate", "multiply", new { a = 2, b = 3 });
            Console.WriteLine("2 * 3 = " + result.ToString());

            //call CalculteService.Divide method
            result = ServiceDispatcher.Dispatch<int>("calculate", "divide", new { a = 2, b = 3 });
            Console.WriteLine("2 / 3 = " + result.ToString());

            Console.Read();
        }
    }
}
